package test;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.test.annotation.Rollback;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import test.config.JpaConfiguration;

import javax.persistence.*;
import java.util.List;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {JpaConfiguration.class})
public class EntityManagerFactoryTest {

    @Autowired
    private CategoryRepository categoryRepository;

    @Test
    public void test2() {
        List<Category> list = categoryRepository.findAllStartsWithA();
        System.out.println(list);
    }

    @PersistenceUnit
    private EntityManagerFactory emf;

    @PersistenceContext
    private EntityManager em;

    @Test
    public void test1() {
        Category category = emf.createEntityManager().find(Category.class, 52);
        System.out.println(category);

        category = em.find(Category.class, 52);
        System.out.println(category);
    }

    @Test
    @Modifying
    @Transactional
    @Rollback(false)
    public void test3() {
        categoryRepository.updateCategory();
    }


}
